//########################
//IllustratorCS4で埋め込まれている画像をPSDで書き出し
//リンクファイルに置き換えます。
//たけうちとおる
//########################

main();
function main(){
	if (app.documents.length == 0){
		alert("ドキュメントを開いてください");
		return;
	}
	if (app.selection.length == 0){
		alert("埋め込まれた画像を1つ以上選択してください");
		return;
	}
	 
	var  seleCount = app.selection.length;
	 mySeleAry = app.selection;
	for(var sN  = 0;sN < seleCount;sN++){
		var mySele = mySeleAry[sN];
		relink_image(mySele);
	}
}
function relink_image(mySele){
	var myitem_type = mySele.typename;
	//alert(mySele.imageColorSpace);
	//var motofilename = decodeURI(mySele.file);
	//return;
	if(myitem_type != "RasterItem"){
		alert("埋め込まれた画像を1つ選択してください");
		return;
	}
	var myBBox = mySele.boundingBox;
	var myBounds = mySele.geometricBounds;
	var docuFpath = app.documents[0].fullName;
	var tempFpath = newFileName(docuFpath);
	var newDocu = app.documents.add();
	//var newDocu = app.documents.add(DocumentColorSpace.CMYK);
	var newobj = mySele.duplicate(newDocu);
	newobj. position = Array(0,0);
	//横長か縦長か
	if(myBounds[2]-myBounds[0] > myBounds[1]-myBounds[3]){
		//こっち横長配置
		if(myBBox[2] > myBBox[1]){
			//本画像が横長
			newobj.width = myBBox[2]-0.1;
			newobj.height = myBBox[1]-0.1;
		}else{
			newobj.height = myBBox[2]-0.1;
			newobj.width = myBBox[1]-0.1;
		}
	}else{
		//こっちタテ長配置
		if(myBBox[2] > myBBox[1]){
			//本画像が横長
			newobj.height = myBBox[2]-0.1;
			newobj.width = myBBox[1]-0.1;
		}else{
			newobj.width = myBBox[2]-0.1;
			newobj.height = myBBox[1]-0.1;
		}
	}
	var exportPSDOptions = new ExportOptionsPhotoshop();
	exportPSDOptions.resolution = 72;
	exportPSDOptions.imageColorSpace = ImageColorSpace.RGB;//gray:1,RGB:2,CMYK:3
	newDocu.exportFile (tempFpath , ExportType.PHOTOSHOP,exportPSDOptions); 
	newDocu.close(SaveOptions.DONOTSAVECHANGES);
	var replacedImage = app.documents[0].placedItems.add();
	replacedImage.file = tempFpath;				
	replacedImage.position = mySele.position;
	replacedImage.width = mySele.width;
	replacedImage.height = mySele.height;
	replacedImage.move(mySele,ElementPlacement.PLACEAFTER);
	mySele.remove();
}
function newFileName(docuFpath){
	var N = 1;
	var loopFlg = true;
	while(loopFlg){
		var fileObj = new File(docuFpath+N+".psd");
		N++;
		if(! fileObj.exists){
			loopFlg = false;
			return fileObj;
		}
	}
}